Index: /branches/PluginInfrastructure Refactoring/HeuristicLab/Program.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab/Program.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab/Program.cs	(revision 2587)
@@ -26,5 +26,10 @@
 using System.Threading;
 using System.Text;
+using System.Linq;
 using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.PluginInfrastructure.Advanced;
+using System.Runtime.InteropServices;
+using HeuristicLab.PluginInfrastructure.Starter;
+using System.IO;
 
 namespace HeuristicLab {
@@ -32,40 +37,69 @@
     [STAThread]
     static void Main(string[] args) {
-      try {
-        if (args.Length == 0) {  // normal mode
+      if (args.Length == 0) {  // normal mode
+        try {
           Application.EnableVisualStyles();
           Application.SetCompatibleTextRenderingDefault(false);
-          Application.Run(new MainForm());
-        } else if (args.Length == 1) {  // start specific application
-          PluginManager.Manager.Initialize();
+          Application.Run(new StarterForm());
+        }
+        catch (Exception ex) {
+          ShowErrorMessageBox(ex);
+        }
 
-          ApplicationInfo app = null;
-          foreach (ApplicationInfo info in PluginManager.Manager.InstalledApplications) {
-            if (info.Name == args[0])
-              app = info;
-          }
-          if (app == null) {  // application not found
-            MessageBox.Show("Cannot start application.\nApplication " + args[0] + " is not installed.\n\nStarting HeuristicLab in normal mode ...",
-                            "HeuristicLab",
-                            MessageBoxButtons.OK,
-                            MessageBoxIcon.Warning);
-            Application.EnableVisualStyles();
-            Application.SetCompatibleTextRenderingDefault(false);
-            Application.Run(new MainForm());
-          } else {
-            PluginManager.Manager.Run(app);
-          }
+      } else {
+        var cmd = args[0].ToUpperInvariant();
+        string pluginDir = Path.GetFullPath(Application.StartupPath);
+        switch (cmd) {
+          case "START": {
+              if (args.Length != 2) {
+                PrintUsage();
+              } else {
+                Application.EnableVisualStyles();
+                Application.SetCompatibleTextRenderingDefault(false);
+                Application.Run(new StarterForm(args[1]));
+              }
+              break;
+            }
+          case "SHOW": {
+              InstallationManagerConsole managerConsole = new InstallationManagerConsole(pluginDir);
+              managerConsole.Show(args.Skip(1));
+              break;
+            }
+          case "INSTALL": {
+              InstallationManagerConsole managerConsole = new InstallationManagerConsole(pluginDir);
+              managerConsole.Install(args.Skip(1));
+              break;
+            }
+          case "UPDATE": {
+              InstallationManagerConsole managerConsole = new InstallationManagerConsole(pluginDir);
+              managerConsole.Update(args.Skip(1));
+              break;
+            }
+          case "REMOVE": {
+              InstallationManagerConsole managerConsole = new InstallationManagerConsole(pluginDir);
+              managerConsole.Remove(args.Skip(1));
+              break;
+            }
+          default: PrintUsage(); break;
         }
-      }
-      catch (Exception ex) {
-        ShowErrorMessageBox(ex);
       }
     }
 
-    public static void ShowErrorMessageBox(Exception ex) {
-      MessageBox.Show(BuildErrorMessage(ex),
-                      "Error - " + ex.GetType().Name,
-                      MessageBoxButtons.OK,
-                      MessageBoxIcon.Error);
+    private static void PrintUsage() {
+      Console.WriteLine("Usage: HeuristicLab.exe <command> <args>");
+      Console.WriteLine("Commands:");
+      Console.WriteLine("\tstart <application name>");
+      Console.WriteLine("\tshow <plugin name(s)>");
+      Console.WriteLine("\tupdate <plugin name(s)>");
+      Console.WriteLine("\tremove <plugin name(s)>");
+      Console.WriteLine("\tinstall <plugin name(s)>");
+    }
+
+    private static void ShowErrorMessageBox(Exception ex) {
+      MessageBox.Show(null,
+        BuildErrorMessage(ex),
+        "Error - " + ex.GetType().Name,
+        MessageBoxButtons.OK,
+        MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
     }
 
